#pragma once
#include "interrupts/Context.h"
#include <stddef.h>

#define SYS_exit 0
#define SYS_yield 1
#define SYS_sleep 2
#define SYS_write 3

namespace Syscall
{
    void entry(Context* context);
}

void sys_exit(Context* context);
void sys_yield(Context* context);
void sys_sleep(Context* context, uint64_t ms);
void sys_write(Context* context, const char* addr, size_t size);